/* Copyright 1997 Lucent Technologies Inc. - All Rights Reserved */

#define MAXSERVICENAME	256

#define ERRSTR	"remote reported an error:"	/*message escape for errors*/

extern int debug;

#define KEYLEN	0
#define HASHLEN	0

typedef u_char	KEY[KEYLEN];
typedef u_char	DIGEST[HASHLEN];

/* in crypto.c */

/* in crypto_client.c */
extern	char *start_client_crypto(int fd, u_char *key, char *servicename);

/* in crypto_server.c */
extern	char *start_server_crypto(int fd);

/* in crif.c */
extern	void netwrite(int fd, char *buf, int n, char *err);
extern	int netread(int fd, char *buf, int n);
extern	char *dd(DIGEST d);
extern	char *dk(u_char *k);
extern	char *ds(u_char *buf, int len);

/* caller supplied */
extern	char *setservice(char *name, u_char *key);

/* in ssl.c */
extern	int cread(int fd, void *obuf, int blen);
extern	void cwrite(int fd, void *ibuf, int len);
extern	char cerrorstr[];
extern	void cperror(char *msg);
