#include <stdio.h>
#include <mpi.h>

main(int argc, char **argv)
{
  
  char message[20];
  
  int rank;
  
  MPI_Init(&argc,&argv);
  
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  
  if(rank == 0)
    strcpy(message, "Hello MPI World");
    
  MPI_Bcast(message,20, MPI_CHAR, 0, MPI_COMM_WORLD);
    
  printf("This is a message from node %d saying %s\n", rank, message);
    
  MPI_Finalize();
}

