#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996                             *
#*         Northeast Parallel Architectures Center*
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id: set-env.pl,v 1.1 1996/08/21 04:43:39 dincer Exp dincer $
#$Log: set-env.pl,v $
#Revision 1.1  1996/08/21 04:43:39  dincer
#Initial revision
#
   
require 'html-util.pl';

#>-----------------------------------------------------------------<
#> Function    : Defines all constants. Hopefully this will be the 
#>   only file that needs to be modified, when the whole system is
#>   moved to a different location or when the HTTP address is changed.
#> In Arguments: none.
#> Side Effect : on defined constants. 
#>-----------------------------------------------------------------<
sub Define_Constants {

   $DocURL = "http://osprey1.npac.syr.edu:6151/";
   $BinURL = "http://osprey1.npac.syr.edu:6151/cgi-bin/vpl2.01-bin/";

   $DocDir  = "/npac/home/pcrc_hpf/Solaris-httpd_1.5.2a/htdocs/vpl2.01/"; 
   $BinDir  = "/npac/home/pcrc_hpf/Solaris-httpd_1.5.2a/cgi-bin/vpl2.01-bin/";
   $DocName = "index.shtml";

   $FEBinDir = "/project/kyk19/evalsp2/HPFfe/new/frontEnd/bin/";
   $LibDir  = "/npac/home/pcrc_hpf/Solaris-httpd_1.5.2a/cgi-bin/vpl2.01-bin/vpl_debugger/LIBS/";
   $ExecDir  = "/npac/home/pcrc_hpf/Solaris-httpd_1.5.2a/cgi-bin/vpl2.01-bin/vpl_debugger/EXECS/";
   
   $DirInfoDocName = "/vpl2.01/DirInfoRefresh.shtml";

   $username = $ENV{'REMOTE_USER'}; 
   #print "UserName = $username <BR> ";
   #&htmlDie("Security Flaw !! Username is not set ") if (!$username);

   #if (! $username) { $username = "no-user-name"; }
   #if (! @ARGV[0] ) { $username = "guest"; }
   if (! $username) { $username = "guest"; }
   $DemoDir = "/npac/home/pcrc_hpf/class-accounts/" . $username . "/";   
   $targetFile = "example";

   $EditFile = $DemoDir . ".vl_edit"; 
   $TempFile = $DemoDir . ".vl_temp";
## not exist ise create etmek lazim
}
1;

