#define SHALEN	20

typedef struct {
    long totalLength;
    long nbits;
    unsigned long h[5];
    unsigned long w[80];
} SHS_CTX;

#define DIGEST_CTX	SHS_CTX

#define HASH_INIT(x)		shsInit(x)
#define HASH_UPDATE(x,y,z)	shsUpdate(x,y,z)
#define HASH_FINAL(x,y)		shsFinal(x,y)

/* qshs.c */
extern	void shsInit(SHS_CTX *mdContext);
extern	void shsUpdate(SHS_CTX *mdContext, unsigned char *s, unsigned int n);
extern	void shsFinal(SHS_CTX *mdContext, unsigned char *ret);
extern	unsigned char *qshs(unsigned char *s, long n);
