/*
CORTEX.H -- This is the standard header file which is used as the ANS/CHARACTER
            utility programs for defining common macros.
*/

/* Define the standard logicals TRUE and FALSE */
#define         TRUE            (~0)
#define         FALSE           0

/* Define a time delay for creating time delays */
#define         TIME_DELAY      1200000L

/* Define the size of Degit image ( 16 * 16 = 256 pixels ) */
#define         ROW             16
#define         COLUMN          16

/* Define the number of Degits to be trained ( 0 - 9 ) */
#define         CATEGORY        10
#define         TYPE             3   /* number of tpyes of training digits */

/* Define the number of hidden units */
#define         HUNIT           80

/* Define the size of input array */
#define         ITUPLE          256

/* End of CORTEX.H */



