/* 3new.c*/
/*
Purpose:	Blah



*/

#include <stdio.h>
#include <mpi.h>


void main (int argc, char*argv[])
{
  int rank, i, p;
  int next, prev;
  int time, start, finish;
  int temp_send, temp_recv;
  int tag = 0;
  int sum = 0;
  MPI_Status status;
  MPI_Init (&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &p);	/* gets the number of processors */

  /*  Sets the value of next and prev based on the number of processors */
  if (rank == p-1){
   next = 0;}	/*  sets the value of next to zero for the process behind */
		/*  the last process. */
  else{
    next = (rank+1);}
  if (rank == 0){
    prev = (p-1);}
  else{
    prev = (rank-1);}

  temp_send = rank;
  temp_recv = rank;
 
  if (rank == 0)
    {   
     
      start = MPI_Wtime();
    }

  for (i=0; i<p; i++)	/* loops program through p times so that the ring completes */
  {
  
    if((rank%2) == 0)	/*even processes*/
    {
      MPI_Ssend(&temp_send, 1, MPI_INT, next, tag, MPI_COMM_WORLD);
      MPI_Recv(&temp_recv, 1, MPI_INT, prev, tag, MPI_COMM_WORLD, &status); 
      
      sum = sum+temp_send;
      temp_send = temp_recv;
    }
    else
    {
       MPI_Recv(&temp_recv, 1, MPI_INT, prev, tag, MPI_COMM_WORLD, &status); 
       MPI_Ssend(&temp_send, 1, MPI_INT, next, tag, MPI_COMM_WORLD);
        
       sum = sum+temp_send;
       temp_send = temp_recv;
    }
  
  } /* end of for */



    if (rank ==0)
    {
       finish = MPI_Wtime();
    }

    time = finish-start;
   
    printf("Time to pass from one to another: %d\n", time);
    printf("The total sum of all the ranks that were passed is: %d\n", sum);
     
    MPI_Finalize();




}  /*end of main */


