/************************************************************************
 * Purpose:     A program to experiment with point-to-point
 *              communications. 
 *
 * Author:      Ronald Lau CPS615
 *
 ************************************************************************/

#include	<stdio.h>
#include	<mpi.h>

float send_buffer[1000];
float recv_buffer[1000];

void main ( int argc, char *argv[] )
{
     int ierror, rank, size, p, finish, time, start;

     int length=1000;

     MPI_Init(&argc, &argv);

     MPI_Comm_rank(MPI_COMM_WORLD, &rank);

     /* Find out number of processes */
     MPI_Comm_size(MPI_COMM_WORLD, &p);

     start = MPI_Wtime();

     if(rank = 0)
     {
        MPI_Scatter(send_buffer, length/p, MPI_FLOAT, recv_buffer, length/p, MPI_FLOAT, 0, MPI_COMM_WORLD);
   
        MPI_Gather(send_buffer, length/p, MPI_FLOAT, recv_buffer, length/p, MPI_FLOAT, 0, MPI_COMM_WORLD);
     }

     finish = MPI_Wtime();

     time = finish - start;

     printf("Total Time = %d\n", time/200.);

     MPI_Finalize();
}
