/*-------------------------------------------------*/
/*       Lingyun Jin  10-14,1998.                  */
/*       Jackson state University                  */
/*       Computer science Department               */
/*       Assignment 4 for CPS-615.                 */
/* Modify the correlation function,so you will not */
/* unexpected  big result                          */
/*-------------------------------------------------*/

#include  <stdio.h>
#include  <math.h>
#include  <mpi.h>


double f(double,double);         /* Correlation function */

void main(int argc, char *argv[])
{
  int P;                       /* Number of processors */
  int my_rank;                 /* Processor rank       */
  int n=100;  
  double x[100];               
  double y[100];               
  double tmpy[100];
  int i;
  int j; 
  int k;
  int my_n;                 /* number of sum on each processor */
  double my_sum=0.0 ;       /* local sum on my processor */
  double sum=0.0 ;          /* total sum, initial to 0    */
  
   MPI_Status status;
  
   MPI_Init(&argc, &argv);
   MPI_Comm_size(MPI_COMM_WORLD, &P);
   my_n = n/P;
   MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
                            
 
 for(i=0;i<my_n;i++)
   x[i]=1.0;
  for(j=0;j<my_n;j++)
   y[j]=1.0;
  
 /* computer my_sum in each processsor   */

 for(k=0;k<P;k++)

   {for(i=0;i<my_n; i++)
      for(j=0;j<my_n; j++)
      {my_sum+= f(x[i],y[j]);
      
      /* left processor Send y[j] to right processor  */
       MPI_Sendrecv(&y,my_n,MPI_DOUBLE,(my_rank+1+P)%P,1,&tmpy,my_n,MPI_DOUBLE,(my_rank-1+P)%P,1,MPI_COMM_WORLD,&status);
          for(j=0;j<my_n; j++) 
             y[j]=tmpy[j];
       }  
    }
                    

   MPI_Reduce(&my_sum,&sum,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);  
     
     if (my_rank==0)
      {printf("-------------------------------------------------\n");
       printf("my_rank=%d, The computed corelation of the all %d body is %f \n",
	     my_rank,n, sum);
       printf("-------------------------------------------------\n");
      } 
  
  MPI_Finalize();
}

/* end of main */



 double f(double a,double b)
 {
  return (a*a + b*b);     /* compute and return value */
 }


 
