#include <stdio.h>
#include <mpi.h>
#include <string.h>


main(int argc, char* argv) {

int rank;   /* rank of process */
int p;      /* number of process */
int tag=0;  /* tag for messages  */
MPI_Status status;  /* return status for receive */



int source;
int *sendbuf,*recbuf;
int root=0, rbuf[100],sendarray[100];
double start,finish,time;

/* Start up MPI */
MPI_Init(&argc, &argv);

/* Find out process rank */
MPI_Comm_rank(MPI_COMM_WORLD, &rank);

/* Find out number of prosess */
MPI_Comm_size(MPI_COMM_WORLD, &p);

printf("Time\n");
fflush(stdout);
start = MPI_Wtime();

    if(rank == 0){    
       sendbuf = (int *)malloc(p*100*sizeof(int));
       recbuf = (int *)malloc(p*100*sizeof(int));
    } /* enf of if */
    MPI_Scatter(sendbuf,100,MPI_INT,rbuf,100,MPI_INT,root,MPI_COMM_WORLD);

    MPI_Gather(sendarray,100,MPI_INT,recbuf,100,MPI_INT,root,MPI_COMM_WORLD);    
finish = MPI_Wtime();
time = finish - start;

printf("rank: %d time: %f\n",rank,time/200.0);
fflush(stdout);
      
/* Shut down MPI */
MPI_Finalize();
exit(0);
} /* end of main */