/* Copyright 1997 Lucent Technologies Inc. - All Rights Reserved */

#include <stdio.h>
#include <stdlib.h>

#include "u.h"
#include "crypto.h"

char *
start_client_crypto(int fd, u_char *key, char *servicename) {
	char msg[MAXSERVICENAME+1+sizeof(DIGEST)];
	int n = strlen(servicename);

	if (n > MAXSERVICENAME) {
		return "Service name too long";
	}

	cwrite(fd, servicename, n+1);

	if ((n=cread(fd, msg, sizeof(msg))) < 0)
		return cerrorstr;
	if (strcmp(msg, "OK") != 0)
		return msg;
	return 0;
}
