#include <stdio.h>
#include <mpi.h>

void main(int argc, char *argv[])
{
  
  int ierror, rank, size;
  
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  
  if(rank == 0)
    printf("hello world!\n");
  
  ierror = MPI_Comm_size(MPI_COMM_WORLD, &size);
  
  if(ierror != MPI_SUCCESS)
    MPI_Abort(MPI_COMM_WORLD, ierror);
  
  printf("I am processor %d out of total %d\n", rank, size);
  
  MPI_Finalize();
}
