#include <stdio.h>
#include <string.h>
#include "mpi.h"
main(int argc, char* argv[]){
int my_rank;   /*rank of process */
int p;         /*number of processes*/
int source;    /*rank of sender */
int dest;      /*rank of destination*/
int tag=0;     /*tag  for messages*/
char message[100]; /*storage for message*/
MPI_Status status; /*return status for receive*/

/*start up mpi */
MPI_Init(&argc, &argv);
/*find out process rank*/
MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
/* Find out number of processes*/
MPI_Comm_size(MPI_COMM_WORLD,&p);
strcpy(message, "Hello, there in jackson!");
if (my_rank !=0){
/*create message*/
printf("greeting from process %d !\n",my_rank);
dest=0;
/* Use strlen+1 so that \0 gets transmitteted*/
MPI_Send(message, strlen(message)+1, MPI_CHAR, dest,tag,MPI_COMM_WORLD);
}
else
{ /* my_rank==0*/

 for(source=1;source<p;source++)
   {
    MPI_Recv(message,100,MPI_CHAR,source,tag,MPI_COMM_WORLD,&status);
    printf("%s\n",message);
   }
}
MPI_Finalize();
}


